% doublesol02.m
% fd, 6 nov 2006
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% algorithme de Newton a deux variables
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n=100 ; 
dx = 1.1/n ; 
x = zeros(3,3*n) ; y = x ; 
for j = 1:3*n ; xx = -2.2 + j*dx ; x(1:1,j:j) = xx ;  
y(1:1,j:j) = xx**2 + xx - 1 ;   end ; hold off 
plot (x(1:1,:), y(1:1,:) ,';;') ; hold on ; 
dy = dx/2 ; 
for j = 1:3*n ; yy = (j-1)*dy ; y(2:2,j:j) = yy ; 
x(2:2,j:j) = sqrt ( 2*yy*(1+yy*yy)) ; 
x(3:3,j:j) = -sqrt ( 2*yy*(1+yy*yy)) ; end 
plot (x(2:2,:), y(2:2,:) ,'b;;') ; 
plot (x(3:3,:), y(2:2,:) ,'m;;') ; 
%
x0 = -3 ; y0 = 0.5 ; ro = .6 ; 
x = x0 ; y = y0 ; 
plot ( x , y , '*r;;' ) ; 
for j=1:20 ; 
ff = [x**2 + x - y - 1 ; -.5*x**2 + y + y**3 ]  ; 
df = [ 2*x + 1 , -1 ; -x , 1 + 3*y**2 ] ; 
h = -df \ ff ; 
xn = x + ro*h(1) ; yn=y + ro*h(2) ; 
plot ( xn , yn , '*m;;' ) ; 
plot ( [ x xn] , [y yn] , 'g;;' ) ; 
x=xn ; y=yn ;
end ; 
x , y , ff  
jj= .5*(y**2 - x**2  - y*x**2 ) + (x**4 + y**4)/4 
j2 = [-1+y+2*x+3*x**2 , -x ; -x , 1+3*y**2 ] ; eig(j2) 
%
x0 = 3 ; y0 = -1 ; ro = .6 ; 
x = x0 ; y = y0 ; 
plot ( x , y , '*r;;' ) ; 
for j=1:20 ; 
ff = [x**2 + x - y - 1 ; -.5*x**2 + y + y**3 ]  ; 
df = [ 2*x + 1 , -1 ; -x , 1 + 3*y**2 ] ; 
h = -df \ ff ; 
xn = x + ro*h(1) ; yn=y + ro*h(2) ; 
plot ( xn , yn , '*m;;' ) ; 
plot ( [ x xn] , [y yn] , 'g;;' ) ; 
x=xn ; y=yn ;
end ; 
x , y , ff 
jj= .5*(y**2 - x**2  - y*x**2 ) + (x**4 + y**4)/4 
j2 = [-1+y+2*x+3*x**2 , -x ; -x , 1+3*y**2 ] ; eig(j2) 



